%% Initialization
% Generates a csv file per activation function for the activation data (used to create the 3D histograms)
run('config.m');

%%
for a = 1:length(activations)
    [~, ~, YMatrices] = forward(nLayers, activations{a}.trans);

    edges = -2:0.05:2;
    csvData = zeros(nLayers + 1, length(edges) - 1);
    csvData(1, :) = 1:size(csvData, 2);
    
    % Activation data per row
    for i = 1:nLayers
        counts = histcounts(YMatrices{i}, edges);
        csvData(i+1, :) = counts;
    end

    csvwrite(['ActivationFunctions_Hist', activations{a}.name, '.csv'], csvData);
end
