%% Initialization
% The purpose of this script is to generate some histograms (activations and gradients) for a manually set activation function
run('config.m');

%% Network with N(0, 1/sqrt{n})
actFunc = 4;
[WMatrices, UMatrices, YMatrices] = forward(nLayers, activations{actFunc}.trans);
[gradients] = backprop(WMatrices, UMatrices, YMatrices, activations{actFunc}.transDiff);

%% Plotting
figure;
s = 1;
showLayers = 1:5:nLayers;
nShowLayers = length(showLayers);
for i = showLayers
    subplot(2, nShowLayers, s);
    histogram(YMatrices{i}, -2:0.05:2);
    grid on;
    title(sprintf('L%d: \\sigma = %0.3f', i, std(YMatrices{i}(:))));
    xlabel('Y');
    ylabel('Count');
    xlim([-2 2]);
    
    subplot(2, nShowLayers, nShowLayers + s);
    histogram(gradients{i}, -2:0.05:2);
    grid on;
    title(sprintf('L%d: \\sigma = %0.3f', i, std(gradients{i}(:))));
    xlabel('\nabla W');
    ylabel('Count');
    xlim([-2 2]);
    
    s = s + 1;
end

set(findall(gcf, '-property', 'FontSize'), 'FontSize', 14);
set(findall(gcf, '-property', 'FontName'), 'FontName', 'Libertinus Serif');
set(gcf, 'Color', 'w');
