%% Network hyperparameters
nLayers = 21;

%% Activation functions
activations = cell(1, 4);
activations{1}.name = 'tanh';
activations{1}.trans = @(x) tanh(x);
activations{1}.transDiff = @(x) (1 ./ (cosh(x).^2));

activations{2}.name = 'ReLU';
activations{2}.trans = @(x) x .* (x > 0);
activations{2}.transDiff = @(x) double(x > 0);

activations{3}.name = 'ELU';
activations{3}.trans = @(x) x .* double(x >= 0) + (exp(x) - 1) .* double(x < 0);
activations{3}.transDiff = @(x) double(x >= 0) + exp(x) .* double(x < 0);

alpha = 1.6732632423543772848170429916717;
scale = 1.0507009873554804934193349852946;
activations{4}.name = 'SELU';
activations{4}.trans = @(x) scale * (x .* double(x >= 0) + (alpha * exp(x) - alpha) .* double(x < 0));
activations{4}.transDiff = @(x) scale * (double(x >= 0) + (alpha * exp(x)) .* double(x < 0));
