function [WMatrices, UMatrices, YMatrices] = forward(nLayers, trans)
    %% Initialization
    rng(1337, 'combRecursive');

    nData = 500;
    nInput = 300;
    nNeurons = 800;
    scaling = (1 ./ sqrt(nNeurons));
    
    X = randn(nData, nInput);
    
    WMatrices = cell(1, nLayers);
    UMatrices = cell(1, nLayers);
    YMatrices = cell(1, nLayers);

    %% Forward pass
    for i = 1:nLayers
        W = randn(size(X, 2), nNeurons) * scaling;
        U = X * W;
        Y = trans(U);
        X = Y;  % The input to the next layer is the output of the current layer

        WMatrices{i}(:, :) = W;
        UMatrices{i}(:, :) = U;
        YMatrices{i}(:, :) = Y;
    end
end
